/**
 * Created by Ekilei on 22.07.2017.
 */

var fn = {

    actionCheckLoc : function () {

        if(!nw.getState()) {
            fn.showBlock('.blockTryAgain',true);
            fn.setStatus('danger',loc.t('Error: no connection'));
            return;
        }

        if(!gl.lang) {
            var lang = (navigator.language || navigator.systemLanguage || navigator.userLanguage);
            if(lang) lang = lang.substr(0,2);
            if(lang) loc.setLang(lang);
        }

        var data = 'lang='+gl.lang;
        var version = gl.loc ? gl.loc['version'] : '';
        data += '&version='+version;

        fn.setTitle(loc.t('Connecting...'));
        gl.wait = 1;
        $.ajax({
            type: "GET",
            url : gl.server+'api/get-localization',
            dataType : 'json',
            async : false,
            data : data,
            cahce : false,
            timeout : gl.ajax_timeout,

            success : function (newdata) {
                gl.wait = 0;
                if(newdata.version) {
                    //gl.lang = newdata.lang;
                    gl.loc = newdata;
                    loc.save();
                    //fn.addAlert('info',loc.t('New language')+' '+newdata.version,'debug');
                }
                if(newdata.a) {
                    //fn.addAlert('info','lang exist','debug');
                }
                fn.initTemplate();
                fn.actionInit();
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.initTemplate();
                fn.addAlert('danger','<h2>actionCheckLoc</h2><h3>'+s+'</h3> <p> '+x.responseText+ ' </p>','error');
                //fn.nextTask();
                fn.setTitle(loc.t('Init Error'));
                fn.showBlock('.blockTryAgain',true);
            }
        });
    },

    actionInit : function () {
        if(!nw.getState()) {
            fn.showBlock('.blockTryAgain',true);
            fn.setStatus('danger',loc.t('Error: no connection'));
            return;
        }
        fn.setTitle(loc.t('Connecting...'));
        var data = 'init='+hex_md5(device.uuid+':'+device.serial);
        gl.wait = 1;
        $.ajax({
            type: "POST",
            url : gl.server+'api/device-init',
            dataType : 'json',
            async : false,
            data : data,
            cache : false,
            timeout : gl.ajax_timeout,

            success : function(data) {
                gl.wait = 0;
                if(data.r)
                {
                    fn.setTitle('');
                    fn.showBlock('.blockRegister',true);
                }
                else if(!data.e) {
                    fn.actionReady(data);
                } else {
                    fn.addAlert('danger',loc.t(data.e),'error');
                    fn.showBlock('.blockTryAgain',true);
                    fn.setTitle(loc.t('Failure!'));
                }
                //fn.nextTask();
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.addAlert('danger','<h2>actionInit</h2><h3>'+s+'</h3> <p> '+x.responseText+ ' </p>','error');
                //fn.nextTask();
                fn.setTitle(loc.t('Init Error'));
                fn.showBlock('.blockTryAgain',true);
            }

        });
    },


    sendToken : function() {
        var token = $('#token').val();
        if(token.length<16) {
            fn.addAlert('warning',loc.t('Token is short'),'token');
            return;
        }
        if(!nw.getState()) {
            return;
        }
        fn.delAlert('token');
        var data = 'token='+token;
        data += '&model='+device.model;
        data += '&init='+hex_md5(device.uuid+':'+device.serial);
        gl.wait = 1;
        $.ajax({
            type: "POST",
            url : gl.server+'api/device-registration',
            dataType : 'json',
            async : false,
            data : data,
            cache : false,
            timeout : gl.ajax_timeout,

            success : function(data) {
                gl.wait = 0;
                if(!data.e) {
                    btn.addBtn('Back','');
                    fn.actionReady(data);
                } else {
                    fn.addAlert('danger',loc.t(data.e),'error');
                }
                //fn.nextTask();
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.setTitle(loc.t('Send Token Error'));
                fn.addAlert('danger','<h2>sendToken</h2><h3>'+s+'</h3> <p> '+x.responseText+ ' </p>','error');
                //fn.nextTask();
            }

        });
    },

    setVal : function(key,value) {
        window.localStorage.setItem(key,value);
    },

    getVal : function(key) {
        return window.localStorage.getItem(key);
    },

    removeVal : function(key) {
        if(window.localStorage.getItem(key)) window.localStorage.removeItem(key);
    },

    showBlock : function(id,state) {
        var target = $(id);
        if(state) target.removeClass('hidden');
        else target.addClass('hidden');
    },

    showBlockParent : function(id,state,parent) {
        var target = $(id);
        if(parent) {
            for(var i=0; i<parent; i++) target = target.parent();
        }
        if(state) target.removeClass('hidden');
        else target.addClass('hidden');
    },


    sendLastPoint : function() {

        if(!nw.getState()) {
            fn.setStatus('danger',loc.t('Error: no connection'));
            return;
        }

        if(gl.stateForeground) fn.setTitle(loc.t('Connecting...'));
        var utime = loc.getDateString('unix',new Date(),false);
        var hash = hex_md5(gl.uid+':'+gl.key+':'+utime);
        var data = 'lat='+gl.lat+'&lon='+gl.lon+'&spd='+gl.speed+'&rad='+gl.rad+'&utime='+utime;
        data += '&uid='+gl.uid+'&hash='+hash+'&tid='+gl.track;
        gl.wait = 1;

        $.ajax({
            type: "POST",
            url : gl.server+'api/set-last',
            dataType : 'json',
            async : false,
            data : data,
            cache : false,
            timeout : gl.ajax_timeout,

            success : function(data) {
                gl.wait = 0;
                if(data.s)
                {
                    gl.key = data.s;
                    if(gl.stateForeground) fn.setTitle(loc.t('Online'));
                } else if(data.d)
                {
                    fn.setTitle(loc.t('Device unregistred'));
                    fn.addAlert('warning',loc.t(data.d),'error');
                    //fn.actionStop();
                    //gl.stateFTS=1;
                    //fn.actionFTS();
                    fn.setText('');
                    fn.showBlock('.blockActiveButtons',false);
                    fn.actionInit();
                }
                else if(!data.e) {
                    //if(gl.stateForeground) fn.setTitle(loc.t('Online'));
                    fn.actionInit();
                } else {
                    fn.setTitle(loc.t('Offline'));
                    fn.addAlert('danger',loc.t(data.e),'error');
                    //gl.stateFTS=1;
                    //fn.actionFTS();
                    //fn.actionStop();
                    fn.actionInit();
                }
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.updAlert('danger','<h2>sendLastPoint</h2> <h3>'+s+'</h3><p> '+x.responseText+ ' </p><p> '+e.Message+'</p>','error');
                fn.setTitle(loc.t('Send Coords Error'));
                fn.actionInit();
            }

        });
    },

    setStatus : function(type,text) {
      $('#statusbar').attr('class','alert-'+type);
      $('#status').text(text);
    },

    I : function(id){return document.getElementById(id);},

    drawMeter : function(amount,fg){
        if(amount > 1) amount = 1;
        if(amount < 0) amount = 0;
        var bk = "#E0E0E0";
        var c = this.I("dlMeter");
        var ctx=c.getContext("2d");
        var dp=window.devicePixelRatio||1;
        var cw=c.clientWidth*dp, ch=c.clientHeight*dp;
        var sizScale=ch*0.0055;
        if(c.width==cw&&c.height==ch){
            ctx.clearRect(0,0,cw,ch);
        }else{
            c.width=cw;
            c.height=ch;
        }
        ctx.beginPath();
        ctx.strokeStyle=bk;
        ctx.lineWidth=16*sizScale;
        ctx.arc(c.width/2,c.height-58*sizScale,c.height/1.8-ctx.lineWidth,-Math.PI*1.1,Math.PI*0.1);
        ctx.stroke();
        ctx.beginPath();
        ctx.strokeStyle=fg;
        ctx.lineWidth=16*sizScale;
        ctx.arc(c.width/2,c.height-58*sizScale,c.height/1.8-ctx.lineWidth,-Math.PI*1.1,amount*Math.PI*1.2-Math.PI*1.1);
        ctx.stroke();
    },

    setTitle : function (txt) {
        $('#title').html(txt);
    },

    setText : function (txt) {
      $('#content').html(txt);
    },
    setGps : function (gps) {
        $('#gps').html(gps);
    },

    setSpeed : function(val) {
      //$('#speed').html(val+"\u00A0"+'<span>'+loc.t('km/h')+'</span>');
      //fn.setText(loc.t('latitude')+': '+gl.lat+'<br> '+loc.t('longitude')+': '+gl.lon+'<br> '+loc.t('radius')+': '+(gl.rad/100)+loc.t('m')+'<br> '+loc.t('time')+': '+gl.time);

        //fn.setText((gl.lat?gl.lat:'-')+','+(gl.lon?gl.lon:'-')+' @'+' '+(gl.rad?(gl.rad/100):'-')+loc.t('m')+'<br>'+loc.t('time')+': '+gl.time);
        //$('#uint').text(loc.t('km/h'));
        $("#dlText").text(val);
        //var color = loc.speedToColor(val);
        var color = '#309030';
        this.drawMeter(val/100,color);
    },

    addAlert : function (type,txt,marker) {
      var date = new Date();
        var str = '<div class="alert alert-'+type+' group-'+marker+' alert-dismissible" role="alert">' +
          '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' +
          loc.getDateString('display',date,true)+'<br>'+txt +
          '</div>';

      $('#blockAlert').prepend(str);
    },

    delAlert : function (marker) {
      $('.group-'+marker).remove();
    },

    updAlert : function(type,txt,marker) {
        this.delAlert(marker);
        var str = '<div class="alert alert-'+type+' group-'+marker+' alert-dismissible" role="alert">' +
            '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' +
            loc.getDateString('display',date,true)+'<br>'+txt +
            '</div>';

        $('#blockAlert').prepend(str);
    },

    actionTryAgain : function() {
        //fn.newTask('actionInit');
        //fn.task();
        fn.actionInit();
    },

    actionStart : function() {

        if(!nw.getState()) {
            fn.setStatus('danger',loc.t('Error: no connection'));
            return;
        }

        var utime = loc.getDateString('unix',new Date(),false);
        var hash = hex_md5(gl.uid+':'+gl.key+':'+utime);
        var data = 'utime='+utime;
        data += '&uid='+gl.uid+'&hash='+hash;
        gl.wait = 1;

        $.ajax({
            type: "POST",
            url : gl.server+'api/start',
            dataType : 'json',
            async : false,
            data : data,
            cache : false,
            timeout : gl.ajax_timeout,

            success : function(data) {
                gl.wait = 0;
                if(data.s)
                {
                    gl.key = data.s;
                    gl.stateFTS = 1;
                    gl.track = data.tid;
                    cordova.plugins.backgroundMode.enable();
                } else if(data.d)
                {
                    fn.setTitle(loc.t('Device unregistred'));
                    fn.addAlert('warning',loc.t(data.d),'error');
                    //fn.actionStop();
                    fn.setText('');
                    fn.showBlock('.blockActiveButtons',false);
                    fn.actionInit();
                }
                else if(!data.e) {
                    fn.actionInit();
                    //if(gl.stateForeground) fn.setTitle(loc.t('Online'));
                } else {
                    fn.addAlert('danger',loc.t(data.e),'error');
                    //fn.actionStop();
                    fn.actionInit();
                }
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.updAlert('danger','<h2>sendStart</h2> <h3>'+s+'</h3><p> '+x.responseText+ ' </p><p> '+e.Message+'</p>','error');
                fn.setTitle(loc.t('Send Coords Error'));
                fn.actionInit();
            }

        });
    },

    actionStop : function() {

        if(!nw.getState()) {
            fn.setStatus('danger',loc.t('Error: no connection'));
            return;
        }

        var utime = loc.getDateString('unix',new Date(),false);
        var hash = hex_md5(gl.uid+':'+gl.key+':'+utime);
        var data = 'tid='+gl.track+'&utime='+utime;
        data += '&uid='+gl.uid+'&hash='+hash;
        gl.wait = 1;
        $.ajax({
            type: "POST",
            url : gl.server+'api/stop',
            dataType : 'json',
            async : false,
            data : data,
            cache : false,
            timeout : gl.ajax_timeout,

            success : function(data) {
                gl.wait = 0;
                if(data.s)
                {
                    gl.key = data.s;
                    gl.stateFTS = 0;
                    cordova.plugins.backgroundMode.disable();
                } else if(data.d)
                {
                    fn.setTitle(loc.t('Device unregistred'));
                    fn.addAlert('warning',loc.t(data.d),'error');
                    //fn.actionStop();
                    fn.setText('');
                    fn.showBlock('.blockActiveButtons',false);
                    fn.actionInit();
                }
                else if(!data.e) {
                    //if(gl.stateForeground) fn.setTitle(loc.t('Online'));
                    fn.actionInit();
                } else {
                    fn.addAlert('danger',loc.t(data.e),'error');
                    //fn.actionStop();
                    fn.actionInit();
                }
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.updAlert('danger','<h2>sendStop</h2> <h3>'+s+'</h3><p> '+x.responseText+ ' </p><p> '+e.Message+'</p>','error');
                fn.setTitle(loc.t('Send Coords Error'));
                fn.actionInit();
            }

        });

    },

    /*actionGPS : function() {
        gl.stateGPS = !gl.stateGPS;
        if(gl.stateGPS) {
            fn.setTitle(loc.t('Init GPS'));
            BackgroundGeolocation.start();
            $('.btnGPS').html(loc.t('Stop')).removeClass('btn-success').addClass('btn-danger');
        } else {
            fn.setTitle(loc.t('Stopped'));
            BackgroundGeolocation.stop();
            $('.btnGPS').html(loc.t('Start')).removeClass('btn-danger').addClass('btn-success');
            if(gl.stateFTS) fn.actionFTS();
        }
    },*/

    actionFTS : function() {
        //gl.stateFTS = !gl.stateFTS;
        if(!gl.stateFTS) {
            //if(!gl.stateGPS) fn.actionGPS();
            $('.btnFTS').html(loc.t('Stop')).removeClass('btn-success').addClass('btn-danger');
            fn.actionStart();
        } else {
            $('.btnFTS').html(loc.t('Start')).removeClass('btn-danger').addClass('btn-success');
            fn.actionStop();
        }
    },

    onPause : function () {

    },

    onResume : function () {

    },

    actionSignUp : function() {
        window.open(encodeURI(gl.server),'_system','location=yes');
    },

    actionGetToken : function() {
        window.open(encodeURI(gl.server+'device'),'_system','location=yes');
    },

    actionReady : function (data) {
        gl.key = data.key;
        gl.uid = data.uid;
        loc.setLang(data.lang);
        fn.initTemplate();

        fn.setTitle('');
        fn.showBlock('.blockSetToken',false);
        fn.showBlock('.blockBack',false);
        fn.showBlock('.blockActiveButtons',true);
        //fn.showBlock('.blockBtnMap',true);
        fn.showBlock('.blockTryAgain',false);
        fn.setText(loc.t('For translate GPS coords click start'));
        $('.btnMap').attr('disabled',false);
    },

    logoutConfirm : function () {
        $.confirm({
            title: loc.t('Confirm!'),
            content: loc.t('Your device will be unlink from FTS!'),
            buttons: {
                confirm: {
                    text : loc.t('Ok'),
                    action : function () {
                    fn.actionLogout();
                }},
                cancel: {
                    text : loc.t('Cancel'),
                    action : function () {
                }},
            }
        });
    },

    actionLogout : function() {
        var utime = loc.getDateString('unix',new Date(),false);
        var hash = hex_md5(gl.uid+':'+gl.key+':'+utime);
        var data = 'logout=1';
        data += '&uid='+gl.uid+'&hash='+hash+'&utime='+utime;
        gl.wait = 1;
        $.ajax({
            type: "POST",
            url : gl.server+'api/device-logout',
            dataType : 'json',
            async : false,
            data : data,
            cache : false,
            timeout : gl.ajax_timeout,

            success : function(data) {
                gl.wait = 0;
                if(data.s) {
                    fn.setTitle(loc.t('Device unregistred'));
                    fn.addAlert('warning',loc.t(data.s),'error');
                    gl.stateFTS=1;
                    fn.actionFTS();
                    fn.setText('');
                    fn.showBlock('.blockActiveButtons',false);
                    fn.actionExit();
                }
                else if(data.e) {
                    fn.setTitle(loc.t('Failure!'));
                    fn.addAlert('danger',loc.t(data.e),'error');
                }
            },
            error : function(x,s,e) {
                gl.wait = 0;
                fn.addAlert('danger','<h2>actionLogout</h2><h3>'+s+'</h3> <p> '+x.responseText+ ' </p><p> '+e.Message+'</p>','error');
                fn.setTitle(loc.t('Failure!'));
            }

        });
    },

    actionExit : function() {
        //cordova.plugins.backgroundMode.disable();
        //cordova.plugins.notification.local.clearAll();
        //navigator.app.exitApp();
        cordova.plugins.backgroundMode.overrideBackButton();
    },

    actionMap : function() {
        $('.btnMap').attr('disabled',true);
        gl.map = !gl.map;
        fn.showBlock('.blockMap',gl.map);

        if(gl.map) $('.btnMap').addClass('btn-success');
        else $('.btnMap').removeClass('btn-success');

        if(gl.map&&!gl.myMap) {

            (function(w,d,s,l,i){ var f=d.getElementsByTagName(s)[0],
                j=d.createElement(s);j.async=false;j.onload=function (){
                ymaps.ready(function () {
                    $('#maploader').remove();
                    gl.myMap = new ymaps.Map("YMapsID", {
                        center: [gl.lat, gl.lon],
                        zoom: gl.zoom,
                        autoFitToViewport: "always",
                        controls: ['zoomControl','typeSelector','trafficControl']
                    });
                    gl.myGeoObject = new ymaps.Placemark([gl.lat, gl.lon], {
                    }, {
                        preset: 'islands#blackCircleDotIconWithCaption',
                        iconCaptionMaxWidth: '50'
                    });

                    gl.myMap.geoObjects.add(gl.myGeoObject);

                    // Создаем круг.
                    gl.myRadius = new ymaps.Circle([
                        // Координаты центра круга.
                        [gl.lat, gl.lon],
                        // Радиус круга в метрах.
                        (gl.rad/100)
                    ], {
                        // Описываем свойства круга.
                        // Содержимое балуна.
                        //balloonContent: "Радиус круга - 10 км",
                        // Содержимое хинта.
                        //hintContent: "Подвинь меня"
                    }, {
                        // Задаем опции круга.
                        // Включаем возможность перетаскивания круга.
                        draggable: false,
                        // Цвет заливки.
                        // Последний байт (77) определяет прозрачность.
                        // Прозрачность заливки также можно задать используя опцию "fillOpacity".
                        fillColor: "#00FF0077",
                        // Цвет обводки.
                        strokeColor: "#1fff3e",
                        // Прозрачность обводки.
                        strokeOpacity: 0.8,
                        // Ширина обводки в пикселях.
                        strokeWidth: 2
                    });

                    // Добавляем круг на карту.
                    gl.myMap.geoObjects.add(gl.myRadius);


                    $('.btnMap').attr('disabled',false);
                });

            };j.src=
                'https://api-maps.yandex.ru/2.1/?&lang='+gl.lang+'&load=package.map&mode=release';f.parentNode.insertBefore(j,f);
            })(window,document,'script',null,null);


        } else {
            $('.btnMap').attr('disabled',false);
        }
    },

    initTemplate : function() {
        loc.init();
        if(!$('#title').html()) fn.setTitle(loc.t('Init'));

        $('#txtSetToken').html(loc.t('If you have token from site'));
        $('#txtSignUp').html(loc.t('If you have not token you need to sign up to service'));
        $('#txtOr').html(loc.t('or'));
        $('#token').attr('placeholder',loc.t('Set token'));

        $('.btnSignUp').html(loc.t('Sign up'));
        $('.btnSetToken').html(loc.t('Set token'));
        $('.btnGetToken').html(loc.t('Get token'));
        $('.btnApply').html(loc.t('Apply'));
        $('.btnQRCode').html(loc.t('Scan QR-code'));
        //$('#btnStart').html(loc.t('Reset'));
        $('.btnTryAgain').html(loc.t('Try again'));
        //$('.btnStart').html(loc.t('Start'));
        //$('.btnStop').html(loc.t('Stop'));
        $('.btnLogout').html(loc.t('Logout'));
        $('.btnExit').html(loc.t('Exit'));
        $('.btnBack').html(loc.t('Back'));

        $('.btnFTS').html(loc.t($('.btnFTS').html()));
        $('.btnGPS').html(loc.t($('.btnGPS').html()));
        $('#unit').text(loc.t('km/h'));
        this.setSpeed('--')
    },

    scan : function() {
        cordova.plugins.barcodeScanner.scan(
            function (result) {
                if(result.text) {
                    $('#token').val(result.text);
                    $('.btnApply').click();
                }
            },
            function (error) {
            },
            {
                prompt : loc.t("Place a QR-code inside the scan area"), // Android
                formats : "QR_CODE", // default: all but PDF_417 and RSS_EXPANDED
                orientation : "portrait", // Android only (portrait|landscape), default unset so it rotates with the device
            }
        );
    }

};