var app = {
    // Application Constructor
    initialize: function() {
        var date = new Date();
        $('#copyright').html(date.getFullYear());
        $('.version').html(gl.version);
        this.bindEvents();
    },

    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener("backbutton", btn.clickBackButton, false); // перехват кнопки назад
        document.addEventListener("pause", fn.onPause, false);
        document.addEventListener("resume",fn.onResume, false);

    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        screen.orientation.lock('portrait');
        fn.initTemplate();
        fn.showBlock('.blockExit',true);

        cordova.plugins.backgroundMode.setDefaults({ silent: true });
        cordova.plugins.backgroundMode.on('activate', function() {
            cordova.plugins.backgroundMode.disableWebViewOptimizations();
            //cordova.plugins.backgroundMode.disableBatteryOptimizations();
        });

        BackgroundGeolocation.configure({
            locationProvider: BackgroundGeolocation.RAW_PROVIDER,
            desiredAccuracy: BackgroundGeolocation.HIGH_ACCURACY,
            stationaryRadius: 3,
            distanceFilter: 3,
            notificationTitle: loc.t('speed')+': -- '+loc.t('km/h'),
            notificationText: loc.t('GPS init'),
            notificationIconSmall: "@drawable/speed_nan",
            notificationIconLarge: "@drawable/icon",
            debug: false,
            interval: gl.gps_interval,
            fastestInterval: gl.gps_interval,
            activitiesInterval: gl.gps_interval,
            maxLocations: 100,
        });


        BackgroundGeolocation.on('location', function(location) {
            BackgroundGeolocation.startTask(function(taskKey) {
                // execute long running task
                gl.lat = Math.round(location.latitude*gl.decimal)/gl.decimal;
                gl.lon = Math.round(location.longitude*gl.decimal)/gl.decimal;
                gl.rad = Math.round(location.accuracy*100);
                gl.speed = Math.round(parseFloat(location.speed)*100);

                gl.kmh = Math.round(gl.speed*0.36)/10;
                var date = new Date();
                gl.time =  loc.getDateString('display',date,false);

                //if(gl.stateForeground) {
                    fn.setGps(gl.lat+','+gl.lon);
                    fn.setText(loc.t('radius')+': '+(gl.rad/100)+loc.t('m')+'<br> '+loc.t('time')+': '+gl.time);
                    fn.setSpeed(gl.kmh);
                    fn.setStatus('success',loc.t('GPS data received'));
                //}
                if(gl.map&&gl.myMap) {
                    gl.myMap.setCenter([parseFloat(gl.lat),parseFloat(gl.lon)]);
                    gl.myGeoObject.geometry.setCoordinates([parseFloat(gl.lat),parseFloat(gl.lon)]);
                    gl.myRadius.geometry.setCoordinates([parseFloat(gl.lat),parseFloat(gl.lon)]);
                    gl.myRadius.geometry.setRadius(location.accuracy);
                }


                var icon = 'nan';
                if(gl.kmh == 0 ) icon = 0;
                else if(isNaN(gl.kmh)) icon = 'nan';
                else if(gl.kmh>10) icon = gl.kmh;
                else if(gl.kmh>99) icon ='over';
                else {
                    var dec = Math.trunc((gl.kmh-Math.trunc(gl.kmh))*10);
                    icon = Math.trunc(gl.kmh)+'_'+dec;
                }

                BackgroundGeolocation.configure({
                    notificationTitle: loc.t('speed')+': '+gl.kmh+' '+loc.t('km/h'),
                    notificationText: loc.t('lat')+': '+gl.lat+'; '+loc.t('lon')+': '+gl.lon+' @'+(gl.rad/100)+loc.t('m'),
                    notificationIconSmall: "@drawable/speed_"+icon,
                });


                if(gl.stateFTS) {
                    var t = loc.getDateString('unix',date,true);
                    var diff = t-gl.fts_last;
                    //fn.delAlert('cfts');
                    //fn.addAlert('info','<h3>checkLastFTS</h3><p>'+t+'</p><p>'+gl.fts_last+'</p><p>'+diff+'</p>','cfts');
                    if(diff>= gl.fts_interval && !gl.wait) {
                        //fn.delAlert('fts');
                        //fn.addAlert('info','<h3>lastFTS</h3><p>'+t+'</p><p>'+gl.fts_last+'</p><p>'+diff+'</p>','fts');
                        gl.fts_last = t;
                        fn.sendLastPoint();
                    }
                }
                // eg. ajax post location
                // IMPORTANT: task has to be ended by endTask
                BackgroundGeolocation.endTask(taskKey);
            });
        });

        BackgroundGeolocation.on('stationary', function(stationaryLocation) {
            // handle stationary locations here
            //fn.addAlert('warning','<strong>stationary</strong> '+error,'event');
        });

        BackgroundGeolocation.on('error', function(error) {
            //fn.setText('[ERROR] BackgroundGeolocation error:', error.code, error.message);
            fn.addAlert('danger','<strong>'+loc.t('BackgroundGeolocation error')+error.code+'!</strong> '+error.message,'error');
            //gl.stateGPS = 1;
            //fn.actionGPS();
        });

        BackgroundGeolocation.on('start', function() {
            //fn.setText('[INFO] BackgroundGeolocation service has been started');
            fn.setStatus('success',loc.t('GPS init'));
        });

        BackgroundGeolocation.on('stop', function() {
            //fn.setText('[INFO] BackgroundGeolocation service has been stopped');
        });

        BackgroundGeolocation.on('background', function() {
            gl.stateForeground = false;
        });

        BackgroundGeolocation.on('foreground', function() {
            gl.stateForeground = true;
            /*if(gl.stateGPS) {
                fn.setSpeed(gl.kmh);
            }*/
        });

        //fn.showBlock('.blockGPSButtons',true);
        BackgroundGeolocation.start();

        BackgroundGeolocation.switchMode(BackgroundGeolocation.FOREGROUND_MODE);

        btn.updateEvBtn();

        if(nw.getState())
        {
            fn.actionCheckLoc();
        }
        else
        {
            fn.showBlock('.blockTryAgain',true);
        }

    },

    debug : function (kmph) {
        gl.lat = 55.9907017;
        gl.lon = 37.2084883;
        gl.rad = 10000;
        gl.speed = 100;
        gl.kmh = kmph;
        var date = new Date();
        gl.time =  loc.getDateString('display',date,false);

        fn.setGps(gl.lat+','+gl.lon);
        fn.setText(loc.t('radius')+': '+(gl.rad/100)+loc.t('m')+'<br> '+loc.t('time')+': '+gl.time);
        fn.setSpeed(gl.kmh);
        fn.setStatus('success',loc.t('GPS data received'));
    }
};

$(function(){
    app.initialize();
});
