var loc = {
    t : function(text) {
        if(!gl.lang) return text;
        if(gl.loc && gl.loc['data'][text]) return gl.loc['data'][text];
        else return text;
    },

    init : function () {
        gl.lang = this.getLang();
        gl.loc = this.get();
    },

    save : function () {
        window.localStorage.setItem('loc_'+gl.lang,JSON.stringify(gl.loc));
    },

    setLang : function (lang) {
        gl.lang = lang;
        window.localStorage.setItem('lang',lang);
    },

    getLang : function () {
        return window.localStorage.getItem('lang');
    },

    get : function () {
        var get = window.localStorage.getItem('loc_'+gl.lang);
        if(!get) return false;
        return JSON.parse(get);
    },

    getCurrentVersion : function () {
        if(gl.loc && gl.loc['version']) return gl.loc['version'];
        return false;
    },

    getDateString : function(type,obj,mi) {
        switch (type) {
            case 'display' :
                return obj.getFullYear()+'-'+this.get2D(obj.getMonth()+1)+'-'+this.get2D(obj.getDate())+' '+this.get2D(obj.getHours())+':'+this.get2D(obj.getMinutes())+':'+this.get2D(obj.getSeconds())+(mi?'.'+obj.getMilliseconds():'');
                break;
            case 'api' :
                return ''+obj.getFullYear()+this.get2D(obj.getMonth()+1)+this.get2D(obj.getDate())+this.get2D(obj.getHours())+this.get2D(obj.getMinutes())+this.get2D(obj.getSeconds())+(mi?obj.getMilliseconds():'');
                break;
            case 'unix' :
                var tmp = obj.getTime()/1000;
                return mi ? Math.round(tmp) : Math.trunc(tmp);
                break;
        }

        return obj;
    },

    get2D : function(str) {
        str = str.toString();
        //console.log('get2D',str,str.length);
        return str.length == 1 ? "0" + str : str;
    },

    speedToColor : function (int) {
        //console.log('speedToColor',int);
        var met = int;
        if(met>100) met = 100;
        if(met<0) met = 0;

        var max  = 100;
        var fromR  = 0;
        var fromG  = 255;
        var fromB  = 0;

        var toR    = 255;
        var toG    = 0;
        var toB    = 0;

        var deltaR = ((toR - fromR) / max);
        var deltaG =((toG - fromG) / max);
        var deltaB = ((toB - fromB) / max);
        //console.log(deltaR,deltaG,deltaB);

        var R      = Math.round(fromR + met * deltaR);
        var G      = Math.round(fromG + met * deltaG);
        var B      = Math.round(fromB + met * deltaB);

        var color = '#'+this.get2D(R.toString(16))+this.get2D(G.toString(16))+this.get2D(B.toString(16));
        //console.log(color);
        return color;
    },
};